
        org  63000

SCR_CT: equ  23692           ;scroll counter
XBEG:   equ  27100           ;index start   (1252 bytes max.)
HBEG:   equ  XBEG+1252       ;history start (5648 bytes max.)
IBEG:   equ  34000           ;input start
MAXLEN: equ  15              ;maximum match length
MCWORK: equ  65400           ;start of working storage

TXTSCR: equ  MCWORK+40       ;*entered: 1=text, 0=pict
TXTPRT: equ  MCWORK+41       ;*entered: 1=print, 0=don't
ILEN:   equ  MCWORK+42       ;*entered: input length (2048-10000)
IEND:   equ  MCWORK+44       ;=calculated: input end (IBEG+ILEN)
ILAST:  equ  MCWORK+46       ;=calculated: input last byte address (IEND-1)
WWIDTH: equ  MCWORK+48       ;*entered: window width (255-2047)
XCOUNT: equ  MCWORK+50       ;bit index counter
XBIT:   equ  MCWORK+51       ;set if data entry has associated bit index entry
BUFFER: equ  MCWORK+60       ;workspace

PTMP:   equ  MCWORK          ;00 window match start address (temporary)
PBEG:   equ  MCWORK+2        ;02 window match start address (final)
PLEN:   equ  PBEG+2          ;04 window match length
OBYTES: equ  PLEN+2          ;06 encoded bytes output
CPOS:   equ  OBYTES+2        ;08 coding position
CNXT:   equ  CPOS+2          ;10 lookahead pointer
LEND:   equ  CNXT+2          ;12 encoding end
LPOS:   equ  LEND+2          ;14 encoding step; starts at IEND
BBEG:   equ  LPOS+4          ;18 encoded bytes start  (IEND)
WINDIFF:equ  LPOS+6          ;20 (WINZ-PINA+1)-(WWIDTH) flag: 0=equal, else=not equal
PWIDTHF:equ  LPOS+7          ;21 window width (adjusted) flag: 0=zero, else=not zero
WINA:   equ  LPOS+8          ;22 LH window boundary
WINZ:   equ  WINA+2          ;24 RH window boundary
PINA:   equ  WINZ+2          ;26 LH window boundary (adjusted)
DBEG:   equ  PINA+6          ;32 decoded output start; starts at (LEND)+1

PRINTI: equ  $1a1b           ;OUT-NUM-1 print a small integer BC
PRINTS: equ  $203c           ;PR-STRING print a string length BC from DE
PRINTFP:equ  $2de3           ;PRINT-FP  print number on calculator stack
STORES: equ  $2ab6           ;to calculator stack: AEDCB
FETCHS: equ  $2bf1           ;from calculator stack: AEDCB
STAKA:  equ  $2d28           ;to calculator stack: A
STAKBC: equ  $2d2b           ;to calculator stack: BC
FPTOBC: equ  $2da2           ;from calculator stack: BC
FPTOA:  equ  $2dd5           ;from calculator stack: A

;TEXT ENCODING ($00-$7F) - no bit index entry
; 0 matches: 1 byte  : 0fffgggg
; 1 match:   2 bytes : 0bbbbbbb ?fffgggg
;2+ matches: bit index 1  + 3 bytes : 1llllooo oooooooo ffffgggg : len+offhi+offlo+chr
;DATA ENCODING ($80-$FF) -  1 bit index entry
; 0 matches: bit index 0  + 1 byte  : 1fffgggg
; 1 match:   bit index 00 + 2 bytes : 1bbbbbbb ?fffgggg
;2+ matches: bit index 1  + 3 bytes : 1llllooo oooooooo ffffgggg : len+offhi+offlo+chr

PROGLEN:defw PROGEND-OUTPUT+3

        ;output subroutine
OUTPUT: ld   hl,BUFFER
        ld   a,(PLEN)
        cp   1
        jr   z,MATCH1        ;IF PLEN=1
        jr   c,MATCH0        ;IF PLEN=0

;2+ matches: bit index 1  + 3 bytes : 1llllooo oooooooo ffffgggg
MATCH2: ex   af,af'
        exx
        ld   hl,(CNXT)
        ld   a,(hl)          ;A =ffffgggg
        ld   bc,(PBEG)
        sbc  hl,bc
        ld   bc,(PLEN)       ;deduct (CNXT-CPOS)
        sbc  hl,bc           ;HL=lookback offset
        ld   b,h
        ld   c,l
        push bc
        exx

        ;               A        B        C        D
        ;change 4 bytes 0000llll|.....ooo|oooooooo|ffffgggg
        ;    to 3 bytes 1llllooo oooooooo ffffgggg
        pop  bc              ;BC=lookback offset
        ld   d,a             ;D =character at (CNXT)
        ld   a,b
        and  %00000111
        ld   b,a             ;B =00000ooo
        ex   af,af'          ;A =(PLEN)
        sla  a
        sla  a
        sla  a               ;A =0llll000
        or   %10000000       ;A =1llll000
        add  a,b             ;A =1llllooo

        ld   (hl),a          ;A =1llloooo
        inc  hl
        ld   (hl),c          ;C =oooooooo offset
        inc  hl
        ld   (hl),d          ;D =ffffgggg =character
        ld   a,(XCOUNT)
        or   (ix+00)
        ld   (ix+00),a
        call COUNTX
        ld   a,3             ;A =byte copy counter
        jr   OUTEND

COUNTX: ld   a,(XCOUNT)
        srl  a
        jr   nc,NOINCX
        inc  ix              ;increment bit index pointer
        ld   a,%10000000
NOINCX: ld   (XCOUNT),a
        ret

; 1 match:   2 bytes : 0bbbbbbb 0bbbbbbb
; 1 match:   bit index 00 + 2 bytes : 1bbbbbbb 1bbbbbbb
MATCH1: ld   de,(PBEG)
        ld   a,(de)
        ld   (hl),a
        inc  hl
        bit  7,a
        jr   z,NOINC1
        call COUNTX
NOINC1: ld   de,(CNXT)
        ld   a,(de)
        ld   (hl),a
        bit  7,a
        jr   z,NOINC2
        call COUNTX
NOINC2: ld   a,2             ;A =byte copy counter
        jr   OUTEND

; 0 matches: 1 byte  : 0bbbbbbb
; 0 matches: bit index 0  + 1 byte  : 1bbbbbbb
MATCH0: ld   de,(CNXT)
        ld   a,(de)
        bit  7,a
        ld   (hl),a
        jr   z,NOINC0
        call COUNTX
NOINC0: ld   a,1             ;A =byte copy counter

OUTEND: ld   hl,(OBYTES)
        ld   d,0
        ld   e,a
        add  hl,de           ;add DE bytes
        ld   (OBYTES),hl

        ;update history for matched string
        ex   af,af'
        ld   hl,(CPOS)
        ld   a,(PLEN)
        inc  a

        exx
        ld   b,a             ;B'=loop counter
HISTNC: exx
        ld   c,(hl)          ;C =1st char
        inc  hl
        ld   b,(hl)          ;B =2nd char
        dec  hl
        push hl
        ld   hl,HBEG         ;HL=history table pointer

HISTNP: ld   e,(hl)
        inc  hl              ;ad-hi
        ld   d,(hl)          ;DE=history pair address
        ld   a,e
        or   d
        jr   z,HISTUP        ;if at empty slot
       ;ld   a,$FF
       ;cp   d
       ;jp   z,$1555         ;"G - No room for line"
        ex   de,hl           ;HL=history pair address, DE=history table pointer
        ld   a,c             ;occupied slot; compare chars
        cp   (hl)
        jr   nz,HISTEX
        inc  hl
        ld   a,b
        cp   (hl)
HISTEX: ex   de,hl           ;HL=history table pointer
        jr   z,HISTUP        ;if pairs match
        inc  hl              ;ad-lo (next entry)
        jr   HISTNP          ;back to check next entry

HISTUP: pop  de              ;DE=new history pair address
        ld   (hl),d
        dec  hl              ;ad-lo
        ld   (hl),e
        ex   de,hl
        inc  hl              ;HL=address of next matched string char
        exx
        djnz HISTNC
        exx
        ex   af,af'

        ld   de,(PLEN)       ;update pointers by PLEN+1
        inc  de
        ld   hl,(WINA)
        add  hl,de
        ld   (WINA),hl
        ld   hl,(PINA)
        add  hl,de
        ld   (PINA),hl
        ld   hl,(WINZ)
        add  hl,de
        ld   (WINZ),hl
        ld   hl,(CPOS)
        add  hl,de
        ld   (CPOS),hl

        ld   hl,BUFFER
        ld   de,(LPOS)
        ld   b,0
        ld   c,a
        ldir
        ld   (LPOS),de

        cp   2
        ret  nz
        ld   a,$16           ;print progress counter occasionally
        rst  $10
        xor  a
        rst  $10
        rst  $10
        ld   bc,(CPOS)
        call PRINTBC
        ret

        ;ENCODING SETUP
SETUPE: ld   hl,IBEG         ;IBEG=start of input
        push hl           ;1>
        ld   (CPOS),hl       ;(CPOS)=coding position
        ld   bc,(ILEN)
        add  hl,bc
        ld   (IEND),hl       ;(IEND)=end of input
        ld   (LPOS),hl       ;(LPOS)=start of output
        dec  hl
        ld   (ILAST),hl
        ld   de,0
        ld   (OBYTES),de     ;(OBYTES) =encoded bytes output
        ld   hl,$FFFF
        ld   (IBEG-2),hl     ;history end marker

        ld   ix,XBEG+2       ;start of bit index
        ld   a,%10000000
        ld   (XCOUNT),a

        pop  hl           ;1<
        ld   bc,(WWIDTH)     ;WWIDTH=window width
        sbc  hl,bc           ;HL=IBEG-WWIDTH
        ld   (WINA),hl       ;WINA,WINZ=left,right window boundaries
        ld   hl,IBEG
        dec  hl
        ld   (WINZ),hl

        exx
        push hl              ;save H'L' (holds calculator RET address)
        exx

        xor  a
        ld   (PLEN),a
        ld   (PWIDTHF),a
        ld   hl,IBEG
        ld   de,XBEG
        sbc  hl,de
        ld   b,h
        ld   c,l             ;BC=size of history + bit index
        dec  bc
        ex   de,hl           ;HL=XBEG
        ld   (hl),a          ;#
        ld   de,XBEG+1       ;#
        ldir                 ;#clear history & index tables

        ;START OF THE ENCODING LOOP
ENLOOP: ld   hl,(WINA)       ;#3
        ld   de,IBEG
        xor  a
        ld   bc,(WINA)
        sbc  hl,de
        jr   nc,LET_PA       ;IF WINA>=IBEG
        ld   bc,IBEG         ;IF WINA< IBEG
        dec  a

LET_PA: ld   (PINA),bc       ;PINA=adjusted LH window boundary
        ld   (WINDIFF),a
        ld   hl,(WINZ)
        and  a
        sbc  hl,bc
        inc  hl
        ld   b,h
        ld   c,l             ;BC=adjusted window width

        ;loop return point if window is fully open
        ;BC holds CPDR counter
ENLOOPZ:ld   hl,(CPOS)
        ld   de,(IEND)
        and  a
        sbc  hl,de
        jp   nc,EOINPUT       ;end of input

        ld   de,(CPOS)
        ld   (CNXT),de       ;lookahead pointer
        ld   de,0
        ld   (PBEG),de
        ld   (PLEN),de       ;PBEG,PLEN = matched start,length in window
        ld   hl,(WINZ)

        ld   a,(PWIDTHF)
        or   a
        jr   nz,FIND12
        inc  a               ;only done once
        ld   (PWIDTHF),a
        jr   LONGEST

FIND12: exx
        ld   hl,(CPOS)
        ld   c,(hl)          ;C =1st char
        inc  hl
        ld   b,(hl)          ;B =2nd char
        ld   hl,HBEG         ;HL=history table pointer

FINDNP: ld   e,(hl)
        inc  hl              ;ad-hi
        ld   d,(hl)          ;DE=history pair address
        ld   a,e
        or   d
        jr   z,FINDOUT       ;if at empty slot
       ;ld   a,$FF
       ;cp   d
       ;jR   z,FINDOUT       ;or history table full
        ex   de,hl           ;HL=history pair address, DE=history table pointer
        ld   a,c             ;occupied slot; compare chars
        cp   (hl)
        jr   nz,FINDEX
        inc  hl
        ld   a,b
        cp   (hl)
FINDEX: ex   de,hl           ;HL=history table pointer
        jr   z,FINDUP        ;if pairs match
        inc  hl              ;ad-lo (next entry)
        jr   FINDNP          ;back to check next entry

FINDUP: dec  de
        ld   h,d
        ld   l,e             ;HL=DE=match point
        ld   bc,(PINA)       ;BC=LH window boundary (adjusted)
        sbc  hl,bc
        push de
        exx
        pop  de
        jr   c,LONGEST       ;match point < LH window boundary

        sbc  hl,de           ;HL=(current pointer)-(match point)=displacement
        ex   de,hl           ;HL=match point, DE=displacement
        push hl           ;1>
        ld   h,b
        ld   l,c
        sbc  hl,de           ;HL=(current counter)-displacement
        ld   b,h
        ld   c,l             ;BC=new CPDR counter
        pop  hl           ;1<

        ;will search from the history match point, if found,
        ;otherwise from the RH window edge (WINZ), backwards
PA2PZ:  ld   de,(CPOS)
        ld   a,(de)          ;A =character at Coding Position
        cpdr                 ;search backwards for a match
        jr   z,MASTART
        ;no further matches in window; output the last longest match (if any)
        ;(PBEG) & (PLEN) will identify the last longest match found
LONGEST:call OUTPUT
        ld   a,(WINDIFF)
        or   a               ;window fully open?
        jp   nz,ENLOOP       ;no
        ld   bc,(WWIDTH)
        jp   ENLOOPZ

FINDOUT:exx
        jr   PA2PZ

MASTART:push hl           ;1>;preserve match start registers
        exx               ;H'L' was saved prior to entering ENLOOP
        pop  hl           ;1<
        inc  hl
        ld   b,0             ;match length
        ld   de,(CPOS)
        ld   (PTMP),hl       ;match start

        ;determine the extent of the match
MALOOP: ld   a,(ILAST)
        cp   e
        jr   nz,MANEXT1
        ld   a,(ILAST+1)
        cp   d
        jr   z,NEXTSW        ;reached end of input

MANEXT1:ld   a,(CPOS)
        cp   l
        jr   nz,MANEXT2
        ld   a,(CPOS+1)
        cp   h
        jr   z,NEXTSW        ;reached Coding Position

MANEXT2:ld   a,(de)          ;compare lookahead character
        cp   (hl)            ;   with window character
        jr   nz,NEXTSW       ;no further match

        inc  b
        inc  hl              ;window pointer
        inc  de              ;lookahead pointer
        ld   a,b             ;A =new match length
        cp   MAXLEN
        jr   nz,MALOOP

NEXTSW: ld   a,(PLEN)        ;A =longest match length so far
        cp   b
        ld   a,b             ;A =new match length
        jr   nc,NOTLONG

        ld   (CNXT),de
        ld   hl,(PTMP)
        ld   (PBEG),hl
        ld   (PLEN),a

NOTLONG:exx
        cp   MAXLEN
        jr   nc,LONGEST
        ld   a,b
        or   c
        jr   nz,PA2PZ
        jr   LONGEST

EOINPUT:and a
        push ix
        pop  hl
        ld   bc,XBEG+2
        sbc  hl,bc           ;HL=bit index full bytes
        sla  l
        rl   h
        sla  l
        rl   h
        sla  l
        rl   h               ;HL*8=bits in full bytes of bit index
        ld   de,0
        ld   a,(XCOUNT)
SCOUNT: inc  e
        sla  a               ;10000000=0, 01000000=1, 00100000=2, etc.
        jr   nc,SCOUNT
        dec  e
        add  hl,de           ;HL=total bits in bit index
        ld   (XBEG),hl       ;store total at start of bit index

        ;DECODING SETUP
SETUPD: call $0d6b           ;CLS
        ld   a,$FE
        call $1601           ;CHAN_OPEN
        call STATS           ;find l() array
        ld   de,(LPOS)
        ld   (LEND),de
        ld   a,$FF
        ld   (de),a          ;end of encoding marker
        inc  de
        ld   a,(TXTPRT)      ;1=print, 0=don't
        or   a
        jr   z,SETDBEG
        ld   a,(TXTSCR)      ;1=text, 0=pict
        or   a
        jr   nz,SETDBEG
        ld   de,16384
SETDBEG:ld   (DBEG),de       ;DE=decoded output start
        ld   hl,(IEND)
        ld   (LPOS),hl       ;HL=encoded output start

        ld   bc,(OBYTES)     ;BC=total encoded bytes (excluding bit index)
        ld   ix,XBEG+2       ;start of bit index
        ld   a,%10000000
        ld   (XCOUNT),a

        ;START OF THE DECODING LOOP
S1TOLP: push bc           ;0>;BC=loop counter
        push hl           ;1>;HL=encoding pointer
        push de           ;2>;DE=decoding pointer
        ld   (PTMP),de

        ld   b,(hl)
        inc  hl
        ld   c,(hl)
        inc  hl
        ld   d,(hl)

        xor  a
        ld   (XBIT),a
        bit  7,b             ;check data type of entry
        jr   z,JUSTL         ;text 1 byte
        inc  a
        ld   (XBIT),a
        ld   a,(XCOUNT)
        and  (ix+00)
        ex   af,af'          ;save Flags
        call COUNTX
        ex   af,af'
        jr   nz,COPYOFF      ;text/data 3 bytes

JUSTL:  ld   d,c             ;text/data 1 byte
        ld   c,b             ;just move down character bytes
        ld   b,0             ;to make room for match length
        ld   a,$FF
        cp   d
        jr   z,COPYBUF       ;at end of encoding
        bit  7,d             ;check for an adjacent 1-byte entry
        jr   z,MATCHED       ;next OK, type 0 1-byte entry
        ld   a,(XCOUNT)      ;next is a type 1 entry, check length
        and  (ix+00)
        jr   nz,COPYBUF      ;next not OK, type 1 3-byte entry
        call COUNTX
        ld   a,(XBIT)
        inc  a
        ld   (XBIT),a
MATCHED:inc  b

COPYBUF:ld   a,b
        cp   2               ;check entry length
        jr   c,KEEPOFF

        ;               B        C        D        E
        ;change 3 bytes 1llllooo oooooooo ffffgggg
        ;    to 4 bytes 0000llll|.....ooo|oooooooo|ffffgggg
COPYOFF:ld   e,d
        ld   d,c
        ld   a,b
        and  %00000111
        ld   c,a
        ld   a,b
        and  %01111000
        srl  a
        srl  a
        srl  a
        ld   b,a

KEEPOFF:ld   a,b             ;A =PLEN
        push af           ;3>
        cp   1
        jr   z,DECODE1       ;IF PLEN=1
        jr   c,DECODE0       ;IF PLEN=0

        ;               B        C        D        E
        ;    to 4 bytes 0000llll|.....ooo|oooooooo|ffffgggg
DECODE2:push de           ; >;save next character: ffffgggg
        ld   l,d
        ld   h,c             ;HL=match offset
        ld   de,(PTMP)       ;DE=decoding pointer
        ex   de,hl
        sbc  hl,de           ;HL=copy point  from decoded output
        ld   c,a
        ld   b,0             ;BC=copy length from decoded output
        push bc           ;4>
        ld   de,BUFFER       ;DE=copy point to print buffer
        ldir
        pop  bc           ;4<
        inc  bc
        pop  hl           ; <
        ld   a,l             ;A =next char after matched string
        ld   (de),a
        jr   PRINTDE

DECODE1:ld   h,d
        ld   de,BUFFER
        ld   a,c
        ld   (de),a
        inc  de
        ld   a,h
        ld   (de),a
        ld   bc,2
        jr   PRINTDE

DECODE0:ld   de,BUFFER
        ld   a,c
        ld   (de),a
        ld   bc,1

PRINTDE:ld   de,BUFFER
        push bc           ;4>
        ld   a,(TXTSCR)      ;1=text, 0=pict
        or   a
        jr   z,NOPRINT
        ld   a,(TXTPRT)      ;1=print, 0=don't
        or   a
        jr   z,NOPRINT
        call PRINTS
NOPRINT:pop  bc           ;4<
        pop  af           ;3<;A =PLEN
STATPOS:call STATLEN
        ld   hl,BUFFER
        pop  de           ;2<
        ldir

        pop  hl           ;1<;HL=current LPOS
        pop  bc           ;0<
        cp   1
        jr   z,TWOBYTE       ;IF PLEN=1
        jr   c,ONEBYTE       ;IF PLEN=0
        inc  hl
        dec  bc
TWOBYTE:inc  hl
        dec  bc
ONEBYTE:inc  hl
        dec  bc
        ld   a,b
        or   c
        jp   nz,S1TOLP

        ;END OF THE DECODING LOOP
        exx
        pop hl               ;restore H'L'
        exx

        ld   de,PRIN
        ld   bc,5
        call PRINTS
        ld   bc,(ILEN)
        call PRINTBC

        ld   de,PROUT
        ld   bc,5
        call PRINTS

        ld   bc,(OBYTES)
        call STAKBC
        ld   bc,(XBEG)
        call STAKBC
        ld   a,8
        call STAKA
        rst  $28
        defb $05   ;divide   ;(XBEG)/8 = bit index bytes
        defb $0F   ;add      ;(XBEG)/8 + (OBYTES) = total bytes output
        defb $31   ;duplicate
        defb $38   ;end_calc
        call PRINTFP

        ld   de,PRAT
        ld   bc,4
        call PRINTS
        ld   bc,(IEND)
        ld   (BBEG),bc
        call PRINTBC

        ld   de,PRDIFF
        ld   bc,6
        call PRINTS
        ld   bc,(ILEN)
        call STAKBC          ;b,l
        rst  $28
        defb $C5   ;store_M5
        defb $03   ;subtract ;b-l
        defb $E5   ;recall_M5;b-l,l
        defb $A4   ;const_ten;b-l,l,10
        defb $A4   ;const_ten;b-l,l,10,10
        defb $04   ;multiply ;b-l,l,100
        defb $01   ;exchange ;b-l,100,l
        defb $05   ;divide   ;b-l,100/l
        defb $04   ;multiply ;(b-l)*100/l
        defb $27   ;int      ;INT ((b-l)*100/l)=diff
        defb $31   ;duplicate;diff,diff
        defb $29   ;sgn      ;diff,SGN diff
        defb $38   ;end_calc
        call FPTOA
        jr   nz,NEGDIF
        ld   a,"+"
        rst  $10
NEGDIF: call PRINTFP         ;diff
        ld   a,"%"
        rst  $10
        ld   a,$0d
        rst  $10
        ret

PRINTBC:call STAKBC
        call PRINTFP
        ret

PRIN:   defb $0d,$0d
        defm "In"
        defb $06
PROUT:  defb $0d
        defm "Out"
        defb $06
PRAT:   defb $0d
        defm "at"
        defb $06
PRDIFF: defb $0d
        defm "Diff"
        defb $06


;===================


CH_ADD: equ  23645
LVALUE: equ  BUFFER+MAXLEN+1 ;start of l() array values
CLEN:   equ  LVALUE+2        ;entry match length
STATSON:equ  CLEN+2          ;NOP=off,CALL=on
LARRAY: defm "l():"

STATS:  ld   bc,(CH_ADD)
        push bc           ;1>
        ld   bc,LARRAY
        ld   (CH_ADD),bc
        call $28b2           ;LOOK-VARS
        pop  bc           ;1<
        ld   (CH_ADD),bc
        jp   c,$1c2e         ;"2 - Variable not found"
        ld   bc,8
        add  hl,bc
        ld   (LVALUE),hl

        ld   a,(STATSON)
        ld   (STATPOS),a
        ld   (STATPOS+1),a
        ld   (STATPOS+2),a   ;disable statistics
        or   a
        ret  z
        ld   hl,STATLEN
        ld   (STATPOS+1),hl  ;enable statistics
        ret

STATLEN:push de
        push bc
        push af

        ld   (CLEN),a        ;A =entry match length (0-15)
        ld   c,a
        sla  a
        sla  a
        sla  a
        sla  a
        sub  c
        ld   b,0
        ld   c,a             ;BC=l(len) row offset
        ld   hl,(LVALUE)
        add  hl,bc           ;HL=l(len) row address

        call LDAEDCB         ;get l(len,1)
        push hl           ;1>;HL=l(len,2) address
        ld   e,1
        call ADDINT
        call LDAEDCB         ;get l(len,2)
        push hl
        call STORES          ;stack l(len,2)
        pop  hl
        call LDAEDCB         ;get l(len,3)
        ld   a,(CLEN)
        inc  a               ;A =(CLEN)+1 (1-16) = decoded length
        ld   e,a
        call ADDINT
        cp   3
        jr   c,L3PLUS        ;decoded length 1or2, encoded length 1or2 (+0,1or2 bits)
        ld   a,3             ;decoded length 3+,encoded length 3 (+1 bit)

L3PLUS: call STAKA           ;stack len
        ld   a,(XBIT)
        call STAKA
        ld   a,8
        call STAKA
        rst  $28             ;l(len,2),len,b,8
        defb $05  ;divide    ;l(len,2),len,b/8
        defb $0F  ;add       ;l(len,2),len+b/8
        defb $0F  ;add       ;l(len,2)+len+b/8
        defb $38  ;end_calc  ;l(len,2) updated

GOTO80: call FETCHS
        pop  hl           ;1<;HL=l(len,2) address
        call LDLEN2

        pop  af
        pop  bc
        pop  de
        ret

        ;copy an l() value
LDAEDCB:ld   a,(hl)
        inc  hl
        ld   e,(hl)
        inc  hl
        ld   d,(hl)
        inc  hl
        ld   c,(hl)
        inc  hl
        ld   b,(hl)
        inc  hl
        ret

        ;update an l(len,1) or l(len,3) INT value
ADDINT: ld   b,c             ;stored as "00 00 dd cc 00"
        ld   c,d             ;BC=old array smallint
        push hl
        ld   h,0
        ld   l,e             ;E =value to add on
        add  hl,bc
        ex   de,hl           ;DE=new array smallint
        pop  hl              ;HL=next element address
        push hl
        dec  hl
        dec  hl
        ld   (hl),d
        dec  hl
        ld   (hl),e
        pop  hl              ;HL=next element address
        ret

        ;update an l(len,2) value
LDLEN2: ld   (hl),a
        inc  hl
        ld   (hl),e
        inc  hl
        ld   (hl),d
        inc  hl
        ld   (hl),c
        inc  hl
        ld   (hl),b
        inc  hl
        ret


;===================

LABELS: defw OUTPUT, SETUPE, ENLOOP, MALOOP, LONGEST, SETUPD
        defw STATS
PROGEND:defb $FF